/*
 * MultiMail offline mail reader
 * main, error

 Copyright (c) 1996 Kolossvary Tamas <thomas@vma.bme.hu>
 Copyright (c) 1998 William McBrine <wmcbrine@clark.net>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#include "error.h"
#include "interfac.h"

#include <new.h>

Interface		*interface = NULL;
ErrorType		error;
mmail			mm;

void			memError();
void			fatalError(const char *description);

ErrorType::ErrorType()
{
	set_new_handler(memError);
	mygetcwd(origdir, 255);
}

ErrorType::~ErrorType()
{
	mychdir(origdir);
}

const char *ErrorType::getOrigDir()
{
	return origdir;
}

#ifdef SIGWINCH
void sigwinchHandler(int sig)
{
	if (sig == SIGWINCH)
		interface->sigwinch();
	signal(SIGWINCH, sigwinchHandler);
}
#endif

void fatalError(const char *description)
{
	delete interface;
	fprintf(stderr, "\n\nFatal error: %s\n\n", description);
	exit(EXIT_FAILURE);
};

void memError()
{
	fatalError("Out of memory");
}

int main()
{
	interface = new Interface();
#ifdef SIGWINCH
	signal(SIGWINCH, sigwinchHandler);
#endif
	interface->screen_init();
	interface->newstate(packetlist);
	interface->KeyHandle();
	delete interface;
	return EXIT_SUCCESS;
}
